Index: palm/trunk/SOURCE/local_tremain.f90
===================================================================
--- palm/trunk/SOURCE/local_tremain.f90	(revision 4901)
+++ palm/trunk/SOURCE/local_tremain.f90	(revision 1)
@@ -1,34 +1,48 @@
-!> @file local_tremain.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE local_tremain( remaining_time )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: local_tremain.f90,v $
+! Revision 1.14  2006/06/02 15:20:33  raasch
+! Extended to TIT Sun Fire X4600 System (lctit)
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
+! Revision 1.13  2003/05/09 14:39:55  raasch
+! Time measurement on IBM is now done using function irtc, which allows correct
+! measurements for jobs running over the 24:00 timeline
 !
-! 3655 2019-01-07 16:51:22Z knoop
-! Corrected "Former revisions" section
+! Revision 1.12  2003/03/16 09:41:49  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.11  2003/03/14 13:44:20  raasch
+! Print statement for testing removed
+!
+! Revision 1.10  2003/03/12 16:33:55  raasch
+! Extended to NEC-SX6 systems
+!
+! Revision 1.9  2002/12/19 15:49:17  raasch
+! Extended to IBM-Regatta systems
+!
+! Revision 1.8  2001/03/30 07:35:00  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.7  2001/01/22 08:34:53  raasch
+! Module test_variables removed
+!
+! Revision 1.5  1998/07/16 06:51:44  raasch
+! cpp-Direktiven fuer t3ej2 und t3ej5 erweitert
+!
+! Revision 1.4  1998/07/06 12:19:02  raasch
+! + USE test_variables
+!
+! Revision 1.3  1998/03/24 15:27:23  raasch
+! Zeitbestimmung auf t3eh aufgenommen
+!
+! Revision 1.2  1998/03/23 08:39:53  raasch
+! Bestimmung der verbleibenden Zeit auf vpp ergaenzt
 !
 ! Revision 1.1  1998/03/18 20:14:47  raasch
@@ -38,30 +52,61 @@
 ! Description:
 ! ------------
-!> For different operating systems get the remaining cpu-time of the job
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE local_tremain( remaining_time )
+! For different operating systems get the remaining cpu-time of the job
+!------------------------------------------------------------------------------!
 
-
-    USE control_parameters,                                                                        &
-        ONLY:  maximum_cpu_time_allowed
-
-    USE cpulog,                                                                                    &
-        ONLY:  initial_wallclock_time
-
-    USE kinds
-
+    USE control_parameters
+    USE cpulog
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER(idp) ::  count                 !<
-    INTEGER(idp) ::  count_rate            !<
+    REAL ::  remaining_time
+!#if defined( __vpp )
+!    REAL ::  cpu_time_used, rdum
+!#endif
+#if defined( __ibm )
+    INTEGER(8) ::  IRTC
+    REAL       ::  actual_wallclock_time
+#elif defined( __lctit )
+    INTEGER    ::  count, count_rate
+    REAL       ::  actual_wallclock_time
+#endif
 
-    REAL(wp)     ::  current_wallclock_time !<
-    REAL(wp)     ::  remaining_time        !<
+#if defined( __t3eh ) || defined( __t3eb ) || defined( __t3ej2 ) || defined( __t3ej5 )
+
+    CALL MPP_TREMAIN( remaining_time )
+
+!#elif defined( __vpp )
+!
+!    CALL CLOCKV( rdum, cpu_time_used, 0, 2 )
+!    remaining_time = maximum_cpu_time_allowed - cpu_time_used
+
+#elif defined( __ibm )
+
+!    CALL SYSTEM_CLOCK( count, count_rate )
+!    actual_wallclock_time = REAL( count ) / REAL( count_rate )
+    actual_wallclock_time = IRTC( ) * 1E-9
+    remaining_time = maximum_cpu_time_allowed - &
+                     ( actual_wallclock_time - initial_wallclock_time )
+
+#elif defined( __lctit )
 
     CALL SYSTEM_CLOCK( count, count_rate )
-    current_wallclock_time = REAL( count, KIND=wp ) / REAL( count_rate, KIND=wp )
-    remaining_time = maximum_cpu_time_allowed - ( current_wallclock_time - initial_wallclock_time )
+    actual_wallclock_time = REAL( count ) / REAL( count_rate )
+    remaining_time = maximum_cpu_time_allowed - &
+                     ( actual_wallclock_time - initial_wallclock_time )
+
+#elif defined( __nec )
+    
+    CALL TREMAIN( remaining_time )
+    remaining_time = remaining_time / tasks_per_node
+
+#else
+
+!
+!-- No stop due to running out of cpu-time on other machines
+    remaining_time = 9999999.9
+
+#endif
 
  END SUBROUTINE local_tremain
Index: palm/trunk/SOURCE/local_tremain_ini.f90
===================================================================
--- palm/trunk/SOURCE/local_tremain_ini.f90	(revision 4901)
+++ palm/trunk/SOURCE/local_tremain_ini.f90	(revision 1)
@@ -1,34 +1,46 @@
-!> @file local_tremain_ini.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE local_tremain_ini
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: local_tremain_ini.f90,v $
+! Revision 1.13  2007/02/11 13:07:03  raasch
+! Allowed cpu limit is now read from file instead of reading the value from
+! environment variable (see routine parin)
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
+! Revision 1.12  2006/06/02 15:21:09  raasch
+! Extended to TIT Sun Fire X4600 System (lctit)
 !
-! 3655 2019-01-07 16:51:22Z knoop
-! Corrected "Former revisions" section
+! Revision 1.11  2003/05/09 14:40:20  raasch
+! Time measurement on IBM is now done using function irtc, which allows correct
+! measurements for jobs running over the 24:00 timeline
+!
+! Revision 1.10  2003/03/16 09:42:01  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.9  2002/12/19 15:50:31  raasch
+! Measurements extended for IBM
+!
+! Revision 1.8  2001/03/30 07:35:16  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.7  2001/01/22 08:35:38  raasch
+! Module test_variables removed
+!
+! Revision 1.5  1998/07/16 06:52:11  raasch
+! cpp-Direktiven fuer t3ej2 und t3ej5 erweitert
+!
+! Revision 1.4  1998/07/06 12:19:21  raasch
+! + USE test_variables
+!
+! Revision 1.3  1998/03/24 15:27:38  raasch
+! Initialisierung auf t3eh ergaenzt
+!
+! Revision 1.2  1998/03/23 08:40:23  raasch
+! Initialisierung auf vpp ergaenzt
 !
 ! Revision 1.1  1998/03/18 20:15:05  raasch
@@ -38,23 +50,39 @@
 ! Description:
 ! ------------
-!> Initialization of CPU-time measurements for different operating systems
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE local_tremain_ini
+! Initialization of CPU-time measurements for different operating systems
+!------------------------------------------------------------------------------!
 
-
-    USE cpulog,                                                                                    &
-        ONLY:  initial_wallclock_time
-
-    USE kinds
+    USE control_parameters
+    USE cpulog
 
     IMPLICIT NONE
 
-    INTEGER(idp)     ::  count      !<
-    INTEGER(idp)     ::  count_rate !<
+#if defined( __ibm )
+    CHARACTER (LEN=10) ::  value_chr
+    INTEGER            ::  idum
+    INTEGER(8)         ::  IRTC
+#elif defined( __lctit )
+    CHARACTER (LEN=10) ::  value_chr
+    INTEGER            ::  idum
+    INTEGER            ::  count, count_rate
+#endif
+
 
 !
 !-- Get initial wall clock time
+#if defined( __ibm )
+
+    initial_wallclock_time = IRTC( ) * 1E-9
+
+#elif defined( __lctit )
+
     CALL SYSTEM_CLOCK( count, count_rate )
-    initial_wallclock_time = REAL( count, KIND=wp ) / REAL( count_rate, KIND=wp )
+    initial_wallclock_time = REAL( count ) / REAL( count_rate )
+
+#else
+!
+!-- So far, nothing is done on these machines
+#endif
+
 
  END SUBROUTINE local_tremain_ini
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 4901)
+++ palm/trunk/SOURCE/modules.f90	(revision 1)
@@ -1,194 +1,283 @@
-!> @file modules.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
-! ------------------
-!
+ MODULE advection
+
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! array size for profiles increased from 400 to 500
-!
-! 4853 2021-01-25 07:56:09Z raasch
-! array size for profiles increased from 300 to 400
-!
-! 4845 2021-01-18 11:15:37Z raasch
-! -use_cmax and arrays required for radiation boundary conditions
-!
-! 4828 2021-01-05 11:21:41Z Giersch
-! file re-formatted to follow the PALM coding standard
-!
-! 4742 2020-10-14 15:11:02Z schwenkel
-! Implement snow and graupel (bulk microphysics)
-!
-! 4721 2020-10-02 10:21:52Z suehring
-! Change default value spinup_pt_amplitude to 0.0 K
-!
-! 4680 2020-09-16 10:20:34Z gronemeier
-! Add option to fix date or time of the simulation
-!
-! 4658 2020-08-28 18:15:50Z suehring
-! Change default value of dt_spinup
-!
-! 4629 2020-07-29 09:37:56Z raasch
-! support for MPI Fortran77 interface (mpif.h) removed
-!
-! 4581 2020-06-29 08:49:58Z suehring
-! +sums_wschs_ws_l
-!
-! 4574 2020-06-24 16:33:32Z pavelkrc
-!
-! 4572 2020-06-24 10:09:41Z gronemeier
-! Revise description of rotation_angle
-!
-! 4565 2020-06-15 08:30:38Z oliver.maas
-! added pt_surface_heating_rate
-!
-! 4536 2020-05-17 17:24:13Z raasch
-! +qsurf_av, ssurf_av
-!
-! 4505 2020-04-20 15:37:15Z schwenkel
-! Add flag for saturation check
-!
-! 4502 2020-04-17 16:14:16Z raasch
-! Implementation of ice microphysics
-!
-! 4495 2020-04-13 20:11:20Z raasch
-! +restart_data_format, restart_data_format_input|output, include_total_domain_boundaries
-!
-! 4476 2020-03-27 12:56:41Z maronga
-! Renamed variables for subgrids-scale model steering
-!
-! 4473 2020-03-25 21:04:07Z gronemeier
-! moved wall_adjustment_factor to turbulence_closure_mod
-!
-! 4472 2020-03-24 12:21:00Z Giersch
-! Additional switch added to activate calculations in flow_statistics for the kolmogorov length
-! scale
-!
-! 4461 2020-03-12 16:51:59Z raasch
-! +virtual_pe_grid, communicator_configurations
-!
-! 4414 2020-02-19 20:16:04Z suehring
-! - nzb_diff_s_inner, nzb_diff_s_outer, nzb_inner,nzb_outer, nzb_s_inner, nzb_s_outer, nzb_u_inner,
-!   nzb_u_outer, nzb_v_inner, nzb_v_outer, nzb_w_inner, nzb_w_outer
-!
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Introduction of wall_flags_total_0, which currently sets bits based on static topography
-! information used in wall_flags_static_0
-!
-! 4340 2019-12-16 08:17:03Z Giersch
-! Flag for topography closed channel flow with symmetric boundaries introduced
-!
-! 4331 2019-12-10 18:25:02Z suehring
-! - do_output_at_2m, pt_2m_av
-!
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
-!
-! 4301 2019-11-22 12:09:09Z oliver.maas
-! removed recycling_yshift
-!
-! 4297 2019-11-21 10:37:50Z oliver.maas
-! changed variable type of recycling_yshift from LOGICAL to INTEGER
-!
-! 4293 2019-11-12 14:44:01Z Giersch
-! Add origin_date_time
-!
-! 4146 2019-08-07 07:47:36Z gronemeier
-! Added rotation_angle
-!
-! 4184 2019-08-23 08:07:40Z oliver.maas
-! changed allocated length of recycling_method_for_thermodynamic_quantities from 20 to 80 characters
-!
-! 4183 2019-08-23 07:33:16Z oliver.maas
-! removed recycle_absolute_quantities and raq
-! added recycling_method_for_thermodynamic_quantities
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 4173 2019-08-20 12:04:06Z gronemeier
-! add vdi_internal_controls
-!
-! 4172 2019-08-20 11:55:33Z oliver.maas
-! added recycle_absolute_quantities and raq
-!
-! 4168 2019-08-16 13:50:17Z suehring
-! +topo_top_ind
-!
-! 4131 2019-08-02 11:06:18Z monakurppa
-! Add max_pr_salsa to control_parameters. Used in creating profile output for salsa.
-!
-! 4110 2019-07-22 17:05:21Z suehring
-! -advc_flags_1, advc_flags_2
-! +advc_flags_m, advc_flags_s
-!
-! 4109 2019-07-22 17:00:34Z suehring
-! remove old_dt
-!
-! 4079 2019-07-09 18:04:41Z suehring
-! + monotonic_limiter_z
-!
-! 4069 2019-07-01 14:05:51Z Giersch
-! Masked output running index mid has been introduced as a local variable to avoid runtime error
-! (Loop variable has been modified) in time_integration
-!
-! 4017 2019-06-06 12:16:46Z schwenkel
-! increase maximum number of virtual flights
-!
-! 3987 2019-05-22 09:52:13Z kanani
-! Introduce alternative switch for debug output during timestepping
-!
-! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction of additional debug
-! messages
-!
-! 3871 2019-04-08 14:38:39Z knoop
-! Initialized parameter region
-!
-! 3746 2019-02-16 12:41:27Z gronemeier
-! Removed most_method
-!
-! 3648 2019-01-02 16:35:46Z suehring
-! -surface_data_output +surface_output
-!
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of global variables
-!--------------------------------------------------------------------------------------------------!
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Definition of variables for special advection schemes.
-!--------------------------------------------------------------------------------------------------!
- MODULE advection
-
-    USE kinds
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  aex  !< exponential coefficient for the Bott-Chlond advection scheme
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  bex  !< exponential coefficient for the Bott-Chlond advection scheme
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dex  !< exponential coefficient for the Bott-Chlond advection scheme
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  eex  !< exponential coefficient for the Bott-Chlond advection scheme
+! $Log: modules.f90,v $
+! Revision 1.95  2007/02/11 13:18:30  raasch
+! version 3.1b (last under RCS control)
+!
+! Revision 1.94  2006/08/22 14:12:18  raasch
+! +dz_max,
+! id_var_dopts extended for second dimension
+!
+! Revision 1.93  2006/08/04 14:50:58  raasch
+! +c_0, diss, dt_min_part, end_time_prel, particles_per_point, sgs_wfu/v/w_part,
+! use_sgs_for_particles, use_upstream_for_tke needed for the particle package,
+! +dt_sum, e_m, speed_x/y/z/_sgs in particle_type,
+! +dt_dopts, time_dopts, netcdf ids for output of particle time series,
+! do2d_unit and do3d_unit now defined as 2d-arrays, izuf renamed iran
+!
+! Revision 1.92  2006/06/02 15:21:45  raasch
+! +NetCDF ids for the shifted u- and v-grid, +data_output_xy/xz/yz
+!
+! Revision 1.91  2006/04/26 12:22:52  raasch
+! +threads_per_task,
+! sums_l, sums_l_l arrays changed to three dimensions
+!
+! Revision 1.90  2006/04/11 14:58:27  raasch
+! pl_spectra renamed data_output_sp, length of run_identifier increased to 80
+!
+! Revision 1.89  2006/03/14 12:55:52  raasch
+! Default for number_of_particle_groups changed to 1
+!
+! Revision 1.88  2006/03/03 14:26:53  letzel
+! control parameter topography now has length 40
+!
+! Revision 1.87  2006/03/03 08:50:25  raasch
+! Default value for surface_heatflux changed to 9999999.9
+!
+! Revision 1.86  2006/02/23 12:39:14  raasch
+! Version 3.0 with topography
+! index arrays nzb_2d replaced by several new variable dependend arrays
+! (e.g. nzb_u_inner), nzb_diff_2d removed, +new grid point
+! counters ngp_2dh_outer and ngp_3d_inner,
+! +skip time control parameters skip_time_..., +log_message,
+! particle parameters psl, psr, pss, psn, psb, pst, pdx, pdy, pdz
+! are now 1D arrays (1:max_number_of_particle_groups), default of
+! number_of_particle_groups changed to 999999, idum in particle_type renamed
+! tail_id,
+! +data_output, data_output_user, do2d, do3d, doav for new steering of data
+! output,
+! +type_x_int for ghost exchange of integer arrays,
+! +netcdf_64bit for supporting NetCDF 64-bit offset format,
+! +mixing_length_1d, dissipation_1d for steering the 1d-model,
+! +e_min (control parameter for minimum tke), +parameters for assuring a
+! constant volume flow, +prt_count, prt_start_index, particle_advection,
+! ebene renamed section, nt_anz renamed current_timestep_number, anz_y..
+! renamed ngp_y.., nanz_sums, nanz_2dh, nanz_3d renamed ngp_sums, ngp_2dh,
+! ngp_3d, respectively, pl1d_anz, pl2d_.._anz, plts_anz, pl3d_anz renamed
+! dopr_n, pl2d_.._no, dots_n, do3d_n, respectively,
+! ql_v and ql_vp now have the target attribute,
+! average_period_pr1d removed
+!
+! Revision 1.85  2005/12/06 16:40:56  raasch
+! Version 2.11c
+!
+! Revision 1.84  2005/10/20 15:38:23  raasch
+! +id_var_rnop_prt, some values of prt_var_names and prt_var_units changed
+!
+! Revision 1.83  2005/06/29 10:40:30  steinfeld
+! Scalars ug and vg changed into one-dimensional arrays;
+! +ug_surface, ug_vertical_gradient, ug_vertical_gradient_level,
+!  ug_vertical_gradient_level_ind,
+!  vg_surface, vg_vertical_gradient, vg_vertical_gradient_level,
+!  vg_vertical_gradient_level_ind
+!
+! Revision 1.82  2005/06/26 20:03:33  raasch
+! +ql_1, ql_2, ql_m, ql is now a pointer, +variables for cloud droplets (arrays
+! ql_v,ql_vp, pointer ql_c), gas_constant renamed r_d, latent_heat renamed l_v,
+! radius instead of diameter, radius + weighting factor included in
+! particle_type, pl2d and pl3d string length increased from 6 to 10,
+! default of call_psolver_at_all_substeps is TRUE
+!
+! Revision 1.81  2005/05/18 15:36:46  raasch
+! New module netcdf_control, +data_output_format, pl1d_callcount renamed
+! dopr_time_count,
+! default values of pl_spectra and spectra_direction changed
+!
+! Revision 1.80  2005/04/23 09:31:14  raasch
+! Implicit counters i renamed i9 due to declaration conflicts with i in other
+! subroutines (reported by Portland compiler),
+! crmax increased to 100, fcl_factor renamed cfl_factor
+!
+! Revision 1.79  2005/03/26 20:40:48  raasch
+! +variables for non-cyclic boundary conditions, call_psolver_at_all_substeps,
+! default value for residual limit increased from 1E-6 to 1E-4
+!
+! Revision 1.78  2004/04/30 12:30:01  raasch
+! idum added in particle_type for better alignment (decalpha),
+! DATA statements replaced by (/ .../) because of internal compiler errors
+! on decalpha, + indices for direct transpositions z --> y,
+! dt_max_1d increased to 300.0 (from 60.0), +grid_matching,
+! arrays cross_ts_numbers and cross_ts_number_count enlarged,
+! impulse_advec renamed momentum_advec
+!
+! Revision 1.77  2004/01/30 10:30:26  raasch
+! +index arrays nzb_2d, nzb_diff_2d
+!
+! Revision 1.76  2004/01/28 15:25:15  raasch
+! +array tsc for timestep steering, +tu_m, tv_m etc. pointer for additional
+! tendencies needed for Runge-Kutta scheme, +intermediate_timestep_count(_max)
+! type log changed to logpoint due to name conflict with intrinsic log
+!
+! Revision 1.75  2003/10/29 08:58:54  raasch
+! +mg_cycles, mg_switch_to_pe0, mg_switch_to_pe0_level in module
+! control_parameters,
+! +mg_loc_ind in module indices, variables related to particle groups added
+! to module particle_attributes
+!
+! Revision 1.74  2003/08/01 08:40:59  raasch
+! +isclice_dvrp, lock_steering_update, slicer_position_dvrp,
+! slicer_range_limits_dvrp in module dvrp_variables
+!
+! Revision 1.73  2003/05/09 14:41:11  raasch
+! New version number 2.7
+!
+! Revision 1.72  2003/04/25 18:54:39  raasch
+! Module mpi added in module pegrid in case of linux cluster
+!
+! Revision 1.71  2003/04/16 13:27:33  raasch
+! Arrays cross_ts_uy... enlarged
+!
+! Revision 1.70  2003/04/16 13:07:43  raasch
+! Array cross_ts_profiles enlarged
+!
+! Revision 1.69  2003/03/16 09:42:07  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.68  2003/03/14 13:44:52  raasch
+! +random_generator in control_parameters
+!
+! Revision 1.67  2003/03/12 16:34:19  raasch
+! +tasks_per_node in pegrid
+!
+! Revision 1.66  2003/03/04 11:32:50  raasch
+! +type steering, +steering_dvrp in dvrp_variables
+!
+! Revision 1.65  2002/12/19 15:52:37  raasch
+! +initial_wallclock_time in cpulog, +myid_char_14 in pegrid,
+! default value for termination_time_needed now set in check_parameters,
+! array dl_grid removed, +wall_adjustment_factor, dt_restart, restart_time,
+! time_restart
+!
+! Revision 1.64  2002/09/12 13:05:44  raasch
+! Default values of *_vertical_gradient_level changed from 100000.0 to -1.0,
+! +molecular_viscosity, density_ratio
+!
+! Revision 1.63  2002/06/11 13:12:29  raasch
+! Entrys buoyancy, diffusion_e, diffusion_s, diffusion_u, diffusion_v and
+! diffusion_w removed from module pointer_interfaces,
+! length of character variables host + psolver increased to 64 and 16
+!
+! Revision 1.62  2002/05/02 18:53:18  raasch
+! Module singleton moved to a separate file. Arrays e_3, pt_3, q_3, u_3, v_3,
+! w_3 re-introduced. Pointer e_p, pt_p, q_p, u_p, v_p, w_p re-introduced.
+!
+! Revision 1.61  2002/04/16 08:09:32  raasch
+! Information about speed components and start positions included in
+! particle_type, +dt_write_particle_data, particle_advection_start,
+! time_write_particle_data and parameters for particle boundary conditions,
+! +vertical_particle_advection,
+! + variables for scalar boundary conditions and initialization
+!
+! Revision 1.60  2001/11/12 16:05:01  raasch
+! +read_particles_from_restartfile
+!
+! Revision 1.58  2001/09/04 12:00:52  raasch
+! New version number 2.3b
+!
+! Revision 1.57  2001/08/21 09:52:08  raasch
+! +comm_palm, maximum_number_of_tailpoints, maximum_tailpoint_age,
+! minimum_tailpoint_distance, particle_tail_coordinates, superelevation_x,
+! superelevation_y, wall_adjustment
+!
+! Revision 1.56  2001/07/20 13:09:07  raasch
+! +grid_level, maximum_grid_level, cycle_mg, gamma_mg, ngsrb,
+! residual_limit in control_parameters, +dzu_mg, dzw_mg, f1_mg, f2_mg, f3_mg
+! in arrays_3d, +superelevation in dvrp_variables, +nxl_mg .. nzt_mg in
+! indices, +ddx2_mg, ddy2_mg in grid_variables
+!
+! Revision 1.55  2001/07/12 12:13:24  raasch
+! default of bc_e_b changed from (u*)**2+neumann to neumann,
+! +particle_maximum_age, psl-pst, pdx-pdz,
+! default values defined for dvrp_directory, dvrp_file, dvrp_host, dvrp_password
+! SAVE-statements added to all modules
+!
+! Revision 1.54  2001/03/30 07:35:57  raasch
+! Interface for advec_s_bc changed, interface for production_e eliminated,
+! arrays work, work1, e_3, pt_3, q_3, u_3, v_3, w_3 removed,
+! pointer e_p, pt_p, q_p, u_p, v_p, w_p removed,
+! -nw, nw1,
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.53  2001/01/30 01:57:16  raasch
+! +passive_scalar
+!
+! Revision 1.51  2001/01/26 00:31:49  raasch
+! +fft_method, use_surface_fluxes in steuer, +module singleton,
+! +write_particle_informations in particle_attributes
+!
+! Revision 1.49  2001/01/05 15:13:16  raasch
+! new module spectrum for computing spectra, +average_count_sp,
+! averaging_interval_sp, dt_dosp, time_average_sp, time_dosp in module steuer,
+! +spectrum_x, spectrum_y in module statistik
+!
+! Revision 1.48  2001/01/02 17:31:36  raasch
+! openfile has the new type file_status, version updated to 2.1a
+!
+! Revision 1.47  2000/12/30 18:48:53  raasch
+! Default value of mode_dvrp changed
+!
+! Revision 1.46  2000/12/28 13:21:35  raasch
+! version updated to 2.1
+!
+! Revision 1.45  2000/12/28 13:19:35  raasch
+! +mode_dvrp, +interval_..._dvrp, REAL*4 changed to REAL in particle_attributes,
+! +dt_prel, time_prel, -particle_transport
+!
+! Revision 1.44  2000/07/03 13:02:32  raasch
+! version updated to 2.0b
+!
+! Revision 1.43  2000/07/03 12:59:53  raasch
+! +dvrp_directory, dvrp_host, dvrp_password, dvrp_username,
+! new module pointer_interfaces which includes interfaces for subroutines with
+! pointer arguments called in prognostic_equations
+!
+! Revision 1.42  2000/04/27 07:35:56  raasch
+! npex and npey must be defined in general (not only for parallel case)
+!
+! Revision 1.41  2000/04/27 07:07:14  raasch
+! +pt_slope_offset, pt_slope_ref, npex, npey, dt_dvrp, time_dvrp,
+! new module dvrp_variables
+! -dt_plisos, dt_plpart, isosurface_filecount, time_plisos, time_plpart
+! Version 2.0a, all comments translated into English, old revision remarks
+! deleted
+!
+! Revision 1.40  2000/04/13 13:17:25  schroeter
+! Felder fuer Wolkenphysik zu Modul arrays3d hinzugefuegt, neues Modul
+! (cloud_parameters) fuer Wolkenphysikparameter eingefuegt
+!
+! Revision 1.39  2000/01/10  10:05:11  10:05:11  raasch (Siegfried Raasch)
+! +use_ug_for_galilei_tr, Aufteilung der zeitabhaengigen Groessen in pointer
+! und targets, + timestep_count
+! 
+! Revision 1.38  1999/12/28 10:06:52  raasch
+! +Variablen fuer Plot von Isooberflaechen
+!
+! Revision 1.37  1999/11/25 16:26:38  raasch
+! Neues Modul particle_attributes,
+! +Variablen fuer Partikelverlagerung: particle_transport, dt_plpart,
+! Version 1.1e
+!
+! Revision 1.1  1997/07/24 11:21:26  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Definition of variables for special advection schemes
+!------------------------------------------------------------------------------!
+
+    REAL ::  spl_gamma_x, spl_gamma_y
+
+    REAL, DIMENSION(:), ALLOCATABLE   ::  aex, bex, dex, eex, spl_z_x, spl_z_y
+    REAL, DIMENSION(:,:), ALLOCATABLE ::  spl_tri_x, spl_tri_y, spl_tri_zu, &
+                                          spl_tri_zw
 
     SAVE
